Fields/Files are received from top to bottom based on the order in which it is submitted
express-form-post is installed globally. To remove it you can cd into /usr/lib/node_modules and delete it there

req.efp._finished can be set to true through the handleError function or finished function. handleError will always set it 
equal to true while finished will only set it to true if busboy has emitted the finish event and all the files have been
processed already via the store (checked by checking if the amount of keys in the req.files object is the same as the amt of
files that were sent to the store)

handleError will stop files from being uploaded further always

Had an earlier bug with reassigning of object properties. Here's the code snippet

```javascript
this.finished = function(err) {
	console.log("This.finished says req.efp is", req.efp._finished);
	if(req.efp._finished) throw new Error("");
	req.efp._finished = true;
	if(err) return cb(err);
	return cb();
}
this.handleError ? this.handleError : this.handleError = this.finished;

```
setting to undefined so we can redefine. this was causing an earlier bug due to not allowing 
reassign of this.handleError to the newly created this.finished.
(this.finished used function scope req object so it would produce error on multiple uploads)

This is the fix
```javascript
ExpressFormPost.prototype.upload = function(req, res, cb) {
	// reassign in fileHandler
	this.handleError = undefined; 
	// cb is cb in fileHandler param
	fileHandler.bind(this)(req, res, cb);
}
```

Attaching the special "data" event to any readable stream will cause the property of ReadableState flowing to be true. This means data is one of the reserved events that you can attach later and still catch events. For other events that were emitted in busboy such as limit, I need to make sure that I attach them as if they were synchronous because the event would be emitted asap. Data flow is paused until the data event is attached to the stream.